
#import <AppKit/AppKit.h>
#import <MiscAppKit/MiscImageDecoderController.h>

#import "ThumbProtocols.h"

@interface AppController:NSObject <DisplayMethods>
{
	id imageView;
	id thumbView;
        id statusTextField;
        int numberOfThumbnails;
        id splitView;
	id saveFileTypeMatrix;
	id infoPanel;

        NSConnection *serverConnection;
        id thumber;
        BOOL isRunning;
        BOOL job;
	NSArray *filenames;
	unsigned int currentJob;
	NSSavePanel *savePanel;
        NSOpenPanel *openPanel;

	MiscImageDecoderController *imageDecoder;
}

- (void)showInfo:(id)sender;
- (void)stopThumbs:(id)sender;
- (void)newDocument:(id)sender;
- (void)addImages:(id)sender;
- (void)addDirectory:(id)sender;
- (void)showImage:(id)sender;
- (void)applicationDidFinishLaunching:(NSNotification *)notification;
- (BOOL)application:(NSApplication *)theApplication openFile:(NSString *)filename;
- (void)saveDocument:(id)sender;
- (void)saveChangeFileType:(id)sender;
- (void)openDocument:(id)sender;
- (void)saveImage:(id)sender;
- (void)openImage:(id)sender;
- (void)remove:(id)sender;
- (void)splitView:(NSSplitView *)sender resizeSubviewsWithOldSize:(NSSize)oldSize;
- (void)splitView:(NSSplitView *)sender constrainMinCoordinate:(float *)min
    maxCoordinate:(float *)max ofSubviewAt:(int)offset;
- (BOOL)validateMenuItem:(NSMenuItem *)anItem;

@end
