

#define NO_DATA 	0
#define HAS_DATA	1

typedef struct {
	int bitsPerPixel;
        int bitsPerSample;
	int samplesPerPixel;
	int numberOfPlanes; 
	int bytesPerPlane;
	int bytesPerRow; 
        int pixelsHigh; 
	int pixelsWide;
	BOOL isPlanar;
	BOOL hasAlpha;
} ImageInfo;

typedef struct {
	ImageInfo imageInfo;
	ImageInfo thumbnailInfo;
	NSImage *image;
        NSString *filename;
	NSBitmapImageRep *bitmap;
	unsigned char **imagePlanes;
	unsigned char *imageData;
	unsigned char **thumbnailPlanes;
	unsigned char **thumbnailSharpenedPlanes;
	BOOL full;
} TransferData;

	
@protocol DisplayMethods

- (void)setThumber:(id)aThumber;
- (oneway void)provideGlobalData;
- (oneway void)displayGlobalData;

@end

@protocol ThumberMethods

- (oneway void)thumbWithSize:(float)thumbSize;

@end
