
/*
   MiscFileDragMatrix.m

   Copyright (C) 1996 Todd Thomas
   Use is governed by the MiscKit license

   This object is included in the MiscKit by permission from the author
   and its use is governed by the MiscKit license, found in the file
   "LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
   for a list of all applicable permissions and restrictions.
*/

// RCS identification information
static char *rcsID = "$Id: MiscFileDragMatrix.m,v 1.2 1996/10/07 02:49:23 todd Exp $";
static void __AvoidCompilerWarning(void) {if(!rcsID)__AvoidCompilerWarning();}

#import <AppKit/AppKit.h>
#import "MiscFileDragCell.h"
#import "MiscFileDragMatrix.h"

// Class ivars
static Class _dragCellClass = nil;


@implementation MiscFileDragMatrix

/*"
   MiscFileDragMatrix is a subclass of MiscDragMatrix that only overrides
   our #cellClass method so we use the MiscFileDragCell class
   as our default. If you use #setCellClass: to change our default class,
   make sure the new class is also a subclass of MiscFileDragCell.
"*/


+ (void) initialize
/*"
   Our class initializer. Sets MiscFileDragCell to be our cell class.
"*/
{
    if (self == [MiscFileDragMatrix class]) {
        [self setCellClass:[MiscFileDragCell class]];
    }
}
    
+ (Class) cellClass
/*"
   Returns the cell class we'll use to make our cells (unless #prototype
   returns something other than nil). By default it is MiscFileDragCell.
"*/
{
    return _dragCellClass;
}

+ (void) setCellClass:(Class)dragCellClass
/*"
   Sets our cell class.
"*/
{
    _dragCellClass = dragCellClass;
}

@end
