//
//	MiscProgressBarInspector.m -- a simple view class for displaying progress
//		Written and Copyright (c) 1993 by James Heiser.  (jheiser@adobe.com)
//				Version 1.0.  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import "MiscProgressPalette.h"
#import "MiscProgressBarInspector.h"
#import <MiscAppKit/MiscProgressBar.h>

@implementation MiscProgressBarInspector

- init
{
    	NSString *filename;
    	NSBundle *bundle;

        [super init];
    	bundle = [NSBundle bundleForClass:[MiscProgressPalette class]];
    	filename = [bundle pathForResource:@"MiscProgressBarInspector" ofType:@"nib"];
        [NSBundle loadNibFile:filename externalNameTable:
		[NSDictionary dictionaryWithObjectsAndKeys:self, @"NSOwner", nil] 
		withZone:[self zone]];
    	return self;
}

- (void)ok:(id)sender
{
    	id object = [self object];
    
	[object setTicsVisible:[theSwitch intValue]];
	[object setTicsOverBar:[theSwitch2 intValue]];
	[object setTickColor:[tickColorWell color]];
	[object setNumTicks:[tickText intValue]];
	[object setEmphasis:[emphasisText intValue]];
    	return [super ok:sender];
}

- (void)revert:(id)sender
{
    	id object = [self object];
    
	[theSwitch setState:[object isTicsVisible]];
	[theSwitch2 setState:[object isTicsOverBar]];
	[tickColorWell setColor:[object tickColor]];
	[tickText setIntValue:[object numTicks]];
	[emphasisText setIntValue:[object emphasis]];
    	return [super revert:sender];
}

- (BOOL)wantsButtons
{
    	return NO;
}


@end
