#ifndef __MiscExporterAccessoryView_h
#define __MiscExporterAccessoryView_h
//=============================================================================
//
//	Copyright (C) 1996-1997 by Paul S. McCarthy and Eric Sunshine.
//		Written by Paul S. McCarthy and Eric Sunshine.
//			    All Rights Reserved.
//
//	This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the authors
//	and its use is governed by the MiscKit license, found in the file
//	"License.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	
//=============================================================================
//-----------------------------------------------------------------------------
// MiscExporterAccessoryView.h
//
//	SavePanel accessory view for use by the MiscExporter class.
//
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
// $Id: MiscExporterAccessoryView.h,v 1.4 97/04/15 08:57:51 sunshine Exp $
// $Log:	MiscExporterAccessoryView.h,v $
//  Revision 1.4  97/04/15  08:57:51  sunshine
//  v0.125.8: Added "MiscTableScroll/" prefix to #import to facilitate new
//  framework organization.
//  
//  Revision 1.3  97/03/10  10:28:46  sunshine
//  v113.1: For OpenStep conformance, many 'col' methods rename to 'column'.
//  
//  Revision 1.2  97/02/07  13:53:21  sunshine
//  v108: Ported to OPENSTEP 4.1 (gamma).
//-----------------------------------------------------------------------------
extern "Objective-C" {
#import	<AppKit/NSView.h>
}
#import <MiscTableScroll/MiscExporter.h>
@class NSBox, NSPopUpButton;

@interface MiscExporterAccessoryView : NSView
	{
	NSPopUpButton*	formatPop;
	NSPopUpButton*	rowTitlePop;
	NSPopUpButton*	colTitlePop;
	NSPopUpButton*	rowGridPop;
	NSPopUpButton*	colGridPop;
	NSBox*		formatBox;
	NSBox*		rowTitleBox;
	NSBox*		colTitleBox;
	NSBox*		rowGridBox;
	NSBox*		colGridBox;
	}

- (id)initWithFrame:(NSRect)rect
	format:(MiscExportFormat)format
	rowTitle:(MiscExportTitleMode)rowTitle
	colTitle:(MiscExportTitleMode)colTitle
	rowGrid:(MiscExportGridMode)rowGrid
	colGrid:(MiscExportGridMode)colGrid;
- (void)dealloc;
- (MiscExportFormat)format;
- (MiscExportTitleMode)rowTitleMode;
- (MiscExportTitleMode)columnTitleMode;
- (MiscExportGridMode)rowGrid;
- (MiscExportGridMode)colGrid;

@end

#endif // __MiscExporterAccessoryView_h
