/* MiscAutoTextScroller.h created by stark on Fri 04-Apr-1997 */

#import <AppKit/AppKit.h>

//	Note:
//	The view try to load an rtfd of the same name than its class from the app wrapper at instantiation time
//	to enable its use it without writing code (ie just IB stuff and the framework. Good for demos or for adding it to a MiscKit
//	app for which the source would not be avalaible...)

@interface MiscAutoTextScroller : NSView
{
@protected
	NSTextView *itsSourceText;		//	NSTextView that draw the text
	NSImage *itsBgImage;			//	Image where we cache out background
	NSImage *itsTextImage;			//	Image where we cache the full text at good width

	double itsState;			//	Current state. 0: start state
						//	Goes to 1 (end state)

	NSTimeInterval itsScrollTime;		//	Scroll time in seconds
	float itsFrameCountPerSeconds;		//	# frames/seconds

	BOOL itsfIsBuildingCache;		//	Internal hack flag. May event be useless :-)
}

	//	Get/Change text storage
- (NSTextStorage *)textStorage;
- (void)setTextStorage:(NSTextStorage *)aTextStorage;

	//	Convenience method to get storage from a rtf or rtfd file
	//	Returns YES if it worked
- (BOOL)setTextFromRTFDPath:(NSString *)anRtfdPath;

	//	Starting/stopping/querying scroll
- (void)startScroll:sender;
- (void)stopScroll:sender;
- (BOOL)isScrolling;

	//	scrollTime is time to scroll 100 pixels
	//	Default value is 2 seconds for 100 pixels
- (NSTimeInterval)scrollTime;
- (void)setScrollTime:(NSTimeInterval)aTotalTime;

	//	This is the 'maximal' frame count
	//	Default value is 25 frame per seconds
	//	(The view should be small if the computer is not powerful enough)
- (float)frameCountPerSecond;
- (void)setFrameCountPerSecond:(float)aFrameCountPerSeconds;

@end
