//
//	MiscClockView.m -- a simple view class for displaying date/time
//		Written by Scott Anguish Copyright (c) 1993 by Scott Anguish.
//				Version 1.0.  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	
//	Aug 30, 1996 Converted to OpenStep by Jeremy Bettis <jeremy@hksys.com>

#import <AppKit/NSView.h>

@class NSImage, NSTimer, NSCalendarDate;

@interface MiscClockView:NSView
{
	NSImage *	theImage;
	NSRect		clockbase;

	NSRect		imageA;
	NSRect		imageP;

	NSRect		imageColon;
	NSRect		YearColon;
	NSRect		imageAM;
	NSRect		imagePM;

	NSRect		DigitalNumbers[10];
	NSRect		DateNumbers[10];
	NSRect		YearNumbers[10];
	NSRect		DayNames[7];
	NSRect		MonthNames[12];
	NSPoint		colonPosition;

	int            seconds;
	int            minutes;
	int            hours;
	int            date;
	int            month;
	int            year;
	int            weekday;
	int            meridian;

	BOOL           militaryTime;
	BOOL           showYear;

	BOOL           keepingTime;
	BOOL           hidden;

	NSTimer *timedEntry;
}

- initWithFrame:(NSRect)frameRect;
- (void)dealloc;

- (void)setTime:(struct tm *) theTime;

- (void)takeMinuteOfHourFrom:sender;
- (void)takeHourOfDayFrom:sender;
- (void)takeDayOfWeekFrom:sender;
- (void)takeDayOfMonthFrom:sender;
- (void)takeMonthOfYearFrom:sender;

- (void)setSecondOfMinute:(int)theSeconds;
- (void)setMinuteOfHour:(int)theMinutes;
- (void)setHourOfDay:(int)theHours;
- (void)setDayOfWeek:(int)theWeekday;
- (void)setDayOfMonth:(int)theDate;
- (void)setMonthOfYear:(int)theMonth;
- (void)setYearOfCommonEra:(int)theYear;
- (void)setMeridian:(int)theMeridian;
- (void)setDate:(NSCalendarDate *)dateObj;

- (int)yearOfCommonEra;
- (int)monthOfYear;
- (int)dayOfWeek;
- (int)dayOfMonth;
- (int)hourOfDay;
- (int)minuteOfHour;
- (int)secondOfMinute;
- (NSCalendarDate *)calendarDate;

- (BOOL)militaryTime;
- (BOOL)showYear;
- (void)setShowYear:(BOOL)state;
- (void)setMilitaryTime:(BOOL)state;
- (BOOL)keepingTime;
- (void)setKeepingTime:(BOOL)yesno;

- (void)startClock:sender;
- (void)stopClock:sender;
- (void)setToCurrentTime:sender;

- (void)setHide:(BOOL)hide;
- (BOOL)isHidden;

- (void)sizeToFit;
@end
