/*
 * MiscObject
 *
 * General root class for all foundation objects of the framework
 *
 * This class implements its own reference counting scheme,
 * which is much faster than the one implemented by NSObject.
 * (minimum factor 10)
 * This is because NSObject uses a hashtable and we use simply
 * an instance variable. The little more memory used by this
 * implementation should be no problem today.
 *
 * Written by Ingo Feulner <ifeulner@xenon.cube.de>
 * for Cube Informationssysteme GmbH.
 */
#import <foundation/NSObject.h>

@interface MiscObject:NSObject
{
@private
	unsigned int _retainCount;
}

@end