//
//	MiscProgressViewInspector.m -- a simple view class for displaying progress
//		Written originally by Don Yacktman Copyright (c) 1993 by James Heiser.
//				This file is maintained by James Heiser, jheiser@adobe.com.
//				Version 1.0.  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	


#import "MiscProgressViewInspector.h"
#define MISC_TOP_LEVEL
#import "MiscProgressView.subproj/MiscProgressView.h"

@implementation MiscProgressViewInspector

- init
{
    NSString *buf;
    id bundle;
    
    [super init];
    
    bundle = [NSBundle bundleForClass:[MiscProgressView class]];
    buf = [bundle pathForResource:@"MiscProgressViewInspector" ofType:@"nib"];
    [NSBundle loadNibFile:buf externalNameTable:[NSDictionary dictionaryWithObjectsAndKeys:self, @"NSOwner", nil] withZone:[self zone]];
    return self;
}

- (void)ok:sender
{
    if (sender == stepSlider) {
        [[self object] setStepSize:[stepSlider intValue]];
        [stepText setIntValue:[stepSlider intValue]];
    } 
    else if (sender == stepText) {
        [[self object] setStepSize:[stepText intValue]];
        [stepSlider setIntValue:[stepText intValue]];
    }
    [[self object] setBackgroundColor:[backgroundColorWell color]];
    [[self object] setForegroundColor:[foregroundColorWell color]];
    [[self object] setBorderColor:[borderColorWell color]];
}

- (void)revert:sender
{
    int step = [[self object] stepSize];
    [stepSlider setIntValue:step];
    [stepText setIntValue:step];
    [backgroundColorWell setColor:[[self object] backgroundColor]];
    [foregroundColorWell setColor:[[self object] foregroundColor]];
    [borderColorWell setColor:[[self object] borderColor]];
}

- (BOOL)wantsButtons
{
    return NO;
}

@end
