//
//	MiscProgressPieInspector.m -- a simple view class for displaying progress
//		Written and Copyright (c) 1993 by James Heiser.  (jheiser@adobe.com)
//				Version 1.0.  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	


#import "MiscProgressPieInspector.h"
#import "MiscProgressView.subproj/MiscProgressPie.h"

@implementation MiscProgressPieInspector

- init
{
	NSString	*buf;
	id bundle;
    
	[super init];
    
	bundle = [NSBundle bundleForClass:[MiscProgressPie class]];
	buf = [bundle pathForResource:@"MiscProgressPieInspector" ofType:@"nib"];
	[NSBundle loadNibFile:[NSString stringWithCString:[buf cString]] externalNameTable:[NSDictionary dictionaryWithObjectsAndKeys:self, @"NSOwner", nil] withZone:[self zone]];

	return ( self );
}


- (void) ok:(id)sender
{
	[[self object] setPieBackgroundColor:[pieBackgroundColorWell color]];
	[[self object] setHidden:[theCheckBox intValue]];
	[super ok:(id)sender];

	return;
}


- (void) revert:(id)sender
{
	[pieBackgroundColorWell setColor:[[self object] pieBackgroundColor]];
	[theCheckBox setState:[[self object] isHidden]];
	[super revert:(id)sender];

	return;
}

- (BOOL) wantsButtons
{
	return ( NO );
}

@end
