//
//	MiscProgressPie.h -- a simple view class for displaying a pie
//		Written and Copyright (c) 1993 by James Heiser.  (jheiser@adobe.com)
//				Version 1.0.  All rights reserved.
//
//		OPENSTEP conversion and mods:  Todd Anthony Nathan <todd@thoughtful.com>
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import "MiscProgressView.h"

@interface MiscProgressPie : MiscProgressView
{
	BOOL	isHidden;
	NSColor	*pb;
}

/*"Initialization and Destruction Support"*/
- initWithFrame:(NSRect)frameRect;
- (void) dealloc;

/*"Drawing Support"*/
- (void) renderBar;
- (void) renderBorder;

/*"Getter Setter Support"*/
- (void) setPieBackgroundColor:(NSColor *)newPieBackgroundColor;
- (NSColor *) pieBackgroundColor;
- (void) setHidden:(BOOL)aBool;
- (BOOL) isHidden;

/*"Archiving Support"*/
- (id) initWithCoder:(NSCoder *)aDecoder;
- (void) encodeWithCoder:(NSCoder *)aCoder;

/*"Interface Builder Support"*/
- (NSString *) inspectorClassName;

@end
