/* MiscTabActionCell.m 
 *
 * By Bill Edney, Sean Hill, Mark Onyschuk, and Art Isbell
 * Copyright (C) 1996.  Use governed by the MiscKit license.
 */

#import <AppKit/NSActionCell.h>

#define UIHalfGray	[NSColor colorWithDeviceWhite:0.5 alpha:0.0]
#define UILighterGray	[NSColor colorWithDeviceWhite:(21.0/25.0) alpha:0.0]


@class NSImage;

@interface MiscTabActionCell:NSActionCell
{
@private
  float		tabHeight;
  float		tabBezierImageWidth;
  NSColor	*_color;
  NSColor	*_leftUpperSelectedStrokeColor;
  NSColor	*_leftUpperStrokeColor;
  NSColor	*_rightStrokeColor;
  NSColor	*_selectedFillColor;
  NSColor	*_fillColor;
}

// Methods Overridden From the Superclass
- initTextCell:(NSString *)aString;
- (id)initWithCoder:(NSCoder *)coder;
- (void)encodeWithCoder:(NSCoder *)coder;
- (id)copyWithZone:(NSZone *)zone;

- (void)setFont:(NSFont *)fontObj;
- (void)updateForFont;

- (void)setColor:(NSColor *)aColor;

- (NSColor *)color;
- (void)takeColorFrom:sender;
- (NSColor *)leftUpperSelectedStrokeColor;
- (NSColor *)leftUpperStrokeColor;
- (NSColor *)rightStrokeColor;
- (NSColor *)selectedFillColor;
- (NSColor *)fillColor;


- (void)drawInteriorWithFrame:(NSRect)cellFrame inView:(NSView *)controlView;
- (void)highlight:(BOOL)flag withFrame:(NSRect)cellFrame inView:(NSView *)aView;
- (NSSize)cellSizeForBounds:(NSRect)aRect;

- (BOOL)trackMouse:(NSEvent *)theEvent inRect:(NSRect)cellFrame ofView:(NSView *)controlView untilMouseUp:(BOOL)_untilMouseUp;
- (BOOL)startTrackingAt:(NSPoint)startPoint inView:(NSView *)aView;


// Accessor Methods
- (BOOL)isSelected;
@end