/* MiscTabButtonCell.h created by stephane on Sun 15-Dec-1996 */

//
//	MiscTabButtonCell.h --
//		Written by Stephane Corthesy Copyright 1997 by Stephane Corthesy.
//				Version 1.1.  All rights reserved.
//		Based upon MiscTabActionCell 1.5 by Sean Hill, 1995
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"License.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import <AppKit/AppKit.h>

typedef enum _MiscTabButtonCellOrientation {
    MiscTopTab		= 0,
    MiscBottomTab	= 1,
    MiscLeftTab		= 2,
    MiscRightTab	= 3
}MiscTabButtonCellOrientation;

typedef struct __TBCFlags {
#ifdef __BIG_ENDIAN__
    unsigned int	orientation:2;
    unsigned int	doNotRotateText:1;
    unsigned int	doNotRotateImage:1;
    unsigned int	reserved:28;
#else
    unsigned int	reserved:28;
    unsigned int	doNotRotateImage:1;
    unsigned int	doNotRotateText:1;
    unsigned int	orientation:2;
#endif
}_TBCFlags;

@interface MiscTabButtonCell : NSButtonCell <NSCoding>
{
	_TBCFlags	_tbcFlags;
}

+ (void) initialize;
- (id) init;
- (id) initTextCell:(NSString *)aString;
- (id) initImageCell:(NSImage *)anImage;
- (id) initWithCoder:(NSCoder *)coder;
- (void) encodeWithCoder:(NSCoder *)coder;
- (void) drawInteriorWithFrame:(NSRect)cellFrame inView:controlView;
- (BOOL) trackMouse:(NSEvent *)theEvent inRect:(NSRect)cellFrame ofView:(NSView *)controlView untilMouseUp:(BOOL)flag;
- (BOOL) startTrackingAt:(NSPoint)startPoint inView:aView;
- (BOOL) isOpaque;
- (NSSize) cellSizeForBounds:(NSRect)aRect;

- (void) setOrientation:(MiscTabButtonCellOrientation)orientation;
- (MiscTabButtonCellOrientation) orientation;
- (void) setRotateImage:(BOOL)doRotateImage;
- (BOOL) doesRotateImage;
- (void) setRotateText:(BOOL)doRotateText;
- (BOOL) doesRotateText;

@end
