// $Id$

//
// ---------------- MiscDraggableCellMatrix Class Interface -------------------
//
// NSMatrix subclass that supports reordering cells be Control-dragging.
//
// Written by Art Isbell (adapted from NiftyMatrix by Jayson Adams, NeXT
//    Developer Support Team)
// Copyright 1996 by Art Isbell.
// Version 1.0.  All rights reserved.
//
// This notice may not be removed from this source code.
//
// This object is included in the MiscKit by permission from the author
// and its use is governed by the MiscKit license, found in the file
// "License.rtf" in the MiscKit distribution.  Please refer to that file
// for a list of all applicable permissions and restrictions.
//	
// ----------------------------------------------------------------------------
//

// ----------------------------- Header Files ---------------------------------

#import <AppKit/NSMatrix.h>

// ---------------- Typedef, Struct, and Union Declarations -------------------

// --------------------- Constant and Enum Definitions ------------------------

// Notification posted after row has been moved.
extern NSString *MiscMatrixRowDidMove;

@interface MiscDraggableCellMatrix:NSMatrix
{
// -------------------- Instance Variable Declarations ------------------------
@private

    NSWindow *_matrixCache;
    NSWindow *_cellCache;
    NSCell *_activeCell;

@protected
@public
}
// ---------------------- Factory Method Declarations -------------------------

// ---------------- Overridden Instance Method Declarations -------------------

- (void)dealloc;
- (void)mouseDown:(NSEvent *)theEvent;
- (void)drawRect:(NSRect)aRect;

// ------------------- New Instance Method Declarations -----------------------

// ----------------- Delegate Instance Method Declarations --------------------

@end
