// $Id$

//
// ------------ MiscSwitchViewConnectInspector Class Interface ----------------
//
// IB MiscSwitchView Connection inspector.
//
// Written by Art Isbell.
// Copyright 1996 by Art Isbell.
// Version 1.0.  All rights reserved.
//
// This notice may not be removed from this source code.
//
// This object is included in the MiscKit by permission from the author
// and its use is governed by the MiscKit license, found in the file
// "License.rtf" in the MiscKit distribution.  Please refer to that file
// for a list of all applicable permissions and restrictions.
//	
// ----------------------------------------------------------------------------
//

// ----------------------------- Header Files ---------------------------------

#import <InterfaceBuilder/IBInspector.h>

// ---------------- Typedef, Struct, and Union Declarations -------------------

// --------------------- Constant and Enum Definitions ------------------------

@interface MiscSwitchViewConnectInspector:IBInspector
{
// -------------------- Instance Variable Declarations ------------------------
@private

    BOOL _isFirstConnectingRevert;

@protected

    IBOutlet NSBrowser *browser;   // connections browser

@public
}
// ---------------------- Factory Method Declarations -------------------------

// ---------------- Overridden Instance Method Declarations -------------------

- (id)init;

- (IBAction)ok:(id)aSender;
- (IBAction)revert:(id)sender;

- (BOOL)wantsButtons;

// ------------------- New Instance Method Declarations -----------------------

- (void)awakeFromNib;

- (IBAction)selectConnection:(id)aSender;	// browser action
- (IBAction)clickConnectButton:(id)aSender;	// browser double action

- (void)rowDidMove:(NSNotification *)aNotification;

// ----------------- Delegate Instance Method Declarations --------------------

- (int)browser:(NSBrowser *)aBrowser numberOfRowsInColumn:(int)aColumn;
- (void)browser:(NSBrowser *)aBrowser willDisplayCell:(id)aCell atRow:(int)aRow
         column:(int)aColumn;

@end
