/*
 *	Filename: NSString_ext.h
 *	Created : Mon Jan 20 15:23:40 1997
 *	Author  : Vince DeMarco
 *	LastEditDate Was "Tue Jan 21 10:18:18 1997"
 */

#import <Foundation/NSString.h>

@interface NSString (RegexStringExtensions)

/* format is of the form %[0-9]
 * %0 perfroms the equivalent of concatenateStringsFromArray:
 * %[1-9] is the %n-1 element from the data array
 * so if format is "What %1 is %2" and data contains "in the hell","this"
 * the result will be What in the hell is this
 */
+ (NSString *)stringWithFormat:(NSString *)format array:(NSArray *)data;
- (id)initWithFormat:(NSString *)format array:(NSArray *)data;

/* Concatenate all of the strings in array into a new string */
+ (NSString *)concatenateStringsFromArray:(NSArray *)array;
@end
