/*
 *	Filename: RegEx.h
 *	Created : Tue Dec  3 14:23:16 1996
 *	Author  : Vince DeMarco
 *	LastEditDate Was "Tue Jan 21 14:38:04 1997"
 */

#import <Foundation/NSObject.h>
#import <regex/rxposix.h>

@class NSArray,NSString;

@interface RegEx : NSObject <NSCopying, NSCoding>
{
@private
    NSString *_pattern;
    BOOL      _ignoreCase;
    regex_t   _regex;
}

+ (BOOL)validRegexPattern:(NSString *)pattern;

+ (id)regexWithPattern:(NSString *)pattern;
+ (id)regexWithPattern:(NSString *)pattern ignoreCase:(BOOL)flag;

- initWithPattern:(NSString *)pattern;
- initWithPattern:(NSString *)pattern ignoreCase:(BOOL)flag;

- (NSString *)pattern;
- (BOOL)ignoreCase;

- (BOOL)patternMatchesString:(NSString *)string;
- (NSArray *)stringWithComponents:(NSString *)string;

@end
