/*	MiscMMAProcessor.h

	Copyright 1996 Uwe Hoffmann.

	This notice may not be removed from this source code.
	The use and distribution of this software is governed by the
	terms of the MiscKit license agreement.  Refer to the license
	document included with the MiscKit distribution for the terms.

	Version 2 (August 1996)
*/

#import <Foundation/Foundation.h>
#import <mathematica/mathlink.h>

@class MiscMMAProcessor;

@protocol MiscMMAReturnPacketReading

- (void)readReturnPacketWithProcessor:(MiscMMAProcessor *)aProcessor; 

@end


@interface MiscMMAProcessor:NSObject
{
@private
	MLINK lp;
	MLEnvironment le;
	struct {
		NSString *message;
		BOOL error;
		NSString *errorMessage;
	} operationState;
}

/*"Opening, accessing and closing Mathlink connection"*/
- (BOOL)openLink;
- (void)closeLink;
- (MLINK)link;

/*"Packet management"*/
- (BOOL)nextPacketWithTag:(int)tag;
- (BOOL)discardRemainingPackets;

/*"Error and state handling"*/
- (BOOL)error; 
- (NSString *)errorMessage;
- (NSString *)stateMessage;

/*"Executing Mathematica expressions"*/
- (BOOL)enterExpression:(NSString *)expr;

/*"Reading Mathematica results"*/ 
- (NSDictionary *)readReturnWithReader:(id <MiscMMAReturnPacketReading>)reader;
- (NSDictionary *)readReturn;

@end


